<?php

// prep database connection
require "dbsettings.php";
$mysqli = new mysqli($host, $username, $password, $database);

// check connection
if ($mysqli->connect_errno) {
	echo "<b>Failed to connect to MySQL</b>: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;	
	return;
};

// cache device lookups
$lookupSource = $mysqli->query("SELECT deviceId, code FROM devices");
while ($row = $lookupSource->fetch_assoc()) {
    $lookup[$row['deviceId']] = $row['code'];
};
$lookupSource->close();

// loop through outstanding files
if ($handle = opendir('./../uploaded_files')) {
    while (false !== ($file = readdir($handle)))
    {
        if ($file != "." && $file != ".." && strtolower(substr($file, strrpos($file, '.') + 1)) == 'csv')
        {
            processFile($file);
        }
    }
    closedir($handle);
}

// close the connection to finish
$mysqli->close();



/**
    * Process a CSV file
	* @param string $file      Name of the file to process
*/
function processFile($file) {
	global $lookup;
	global $mysqli;
	
    if (($handle = fopen('./../uploaded_files/' . $file, "r")) !== FALSE) {
        while (($data = fgetcsv($handle, 0, ";")) !== FALSE) {
		
		    $continue = false;
		    switch ($data[1]) {
				case 'SEN-34540377-25-04':
					$ValueRow = 2;
					$continue = true;
					break;					
				case 'SEN-35141451-25-04':
					$ValueRow = 2;
					$continue = true;
					break;				
				case 'SEN-35141453-25-04':
					$ValueRow = 2;
					$continue = true;
					break;				
				case 'ELV-54002915-50-00':
					$ValueRow = 9;				
					$continue = true;
					break;
			}
			
			if ($continue) {
				// valid data row, prep the insert
				$date = gmdate("Y-m-d H:i:s", $data[0]);
				$deviceId = 0;
				foreach ($lookup as $key => $value) {
					if ($value == $data[1]) {
						$deviceId = $key;
					};
				};
				
				// check the device id matched
				if ($deviceId == 0) {
					continue;
				};
				
				$sql = "INSERT into devicedata (deviceId, timestamp, value) VALUES ($deviceId, ?, $data[$ValueRow])";
				$statement = $mysqli->prepare($sql);
				$statement->bind_param("s", $date);
				$statement->execute();
				$statement->close();
			}
		
        }
        fclose($handle);
		rename('./../uploaded_files/' . $file, './../processed_files/' . $file);
    }
};

?>