<?php

// determine month and year to display
$useDay = $_GET["day"] == "" ? date("d") : $_GET["day"];
$useMonth = $_GET["month"] == "" ? date("m") : $_GET["month"];
$useYear = $_GET["year"] == "" ? date("Y") : $_GET["year"];


// prep database connection
require $_SERVER['DOCUMENT_ROOT'] . "/muceasy/include/dbsettings.php";
$mysqli = new mysqli($host, $username, $password, $database);

// check connection
if ($mysqli->connect_errno) {
	echo "<b>Failed to connect to MySQL</b>: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;	
	return;
};

// cache device lookups
$lookupSource = $mysqli->query("SELECT deviceId, name, code FROM devices");
while ($row = $lookupSource->fetch_assoc()) {
    $lookup[$row['code']] = $row;
};
$lookupSource->close();

// get report for the required month
buildReport();

// close the connection to finish
$mysqli->close();

function buildReport() {
    global $mysqli;
	global $lookup;
	global $useDay;
	global $useMonth;
	global $useYear;
	
	$prevUNIXtime = mktime(null, null, null, $useMonth, $useDay, $useYear)-60*60*24;
	$prevDay = date("d", $prevUNIXtime);
	$prevMonth = date("m", $prevUNIXtime);
	$prevYear = date("Y", $prevUNIXtime);
	
	$nextUNIXtime = mktime(null, null, null, $useMonth, $useDay, $useYear)+60*60*24;
	$nextDay = date("d", $nextUNIXtime);
	$nextMonth = date("m", $nextUNIXtime);
	$nextYear = date("Y", $nextUNIXtime);
	
	$monthName = date("F", mktime(null, null, null, $useMonth));
	echo "<a href='report_day.php?day=$prevDay&month=$prevMonth&year=$prevYear'>(previous day)</a> &nbsp;&nbsp;&nbsp;";
	echo "<b>$useDay ";
	echo "<a href='report.php?month=$useMonth&year=$useYear'>";
	echo "$monthName $useYear</a></b>";
	echo "&nbsp;&nbsp;&nbsp; <a href='report_day.php?day=$nextDay&month=$nextMonth&year=$nextYear'>(next day)</a>";
	echo "<br />";
	
	echo "<table border='1'>\n";
	echo "<tr style='background-color: #dddddd'>\n";
	echo "<td>Time</td>\n";
	
	foreach ($lookup as $key => $value) {
		if ($key != '') {
			echo "<td>" . $value['name'] . "</td>\n";
		};
	};
	
	echo "</tr>\n";
	
	// collect data for this month
    $dataSource = $mysqli->query("
		select 
			dv.deviceId, dv.name, dv.code,
			hour(d.timestamp)as hour,
			dayofmonth(d.timestamp) as day, 
			month(d.timestamp) as month, 
			year(d.timestamp) as year, 
			max(d.value) - min(d.value) as value,
			avg(d.value) as average
		from 
			devicedata d, devices dv
		where 
				d.deviceid = dv.deviceid
			and	
				dayofmonth(d.timestamp) = $useDay
			and 
				month(d.timestamp) = $useMonth
			and 
				year(d.timestamp) = $useYear
		group by 
			dv.name, year(d.timestamp), month(d.timestamp), dayofmonth(d.timestamp), hour(d.timestamp)
		order by 
			hour(d.timestamp), dayofmonth(d.timestamp), month(d.timestamp), year(d.timestamp)
		");
		
    while ($row = $dataSource->fetch_assoc()) {
		foreach ($lookup as $key => $value) {
			if ($value['code'] == $row['code']) {
			    $dataSort[$row['hour']][$key] = $row['code'] == 'ELV-54002915-50-00' ? $row['average'] : $row['value'];//dataSort = Sorted Data
			};
		};
    };
    $dataSource->close();
	
	// add in data
	if (is_array($dataSort))
	{
		foreach ($dataSort as $key => $row) {
			echo "<tr>\n";
			$keyPlus = $key +1;
			echo "<td>" . sprintf("%02s", $key) . ":00-" . sprintf("%02s", $keyPlus) . ":00</td>\n";
			echo "<td style='text-align: center'>" . $row['SEN-34540377-25-04'] . "</td>\n";
			echo "<td style='text-align: center'>" . $row['SEN-35141451-25-04'] . "</td>\n";
			echo "<td style='text-align: center'>" . $row['SEN-35141453-25-04'] . "</td>\n";
			echo "<td style='text-align: center'>" . $row['ELV-54002915-50-00'] . "</td>\n";
			echo "<td style='text-align: center'>" . $row['ELV-14445906-02-02'] . "</td>\n";
			echo "</tr>\n";
			
			$totals[1] += $row['SEN-34540377-25-04'];
			$totals[2] += $row['SEN-35141451-25-04'];
			$totals[3] += $row['SEN-35141453-25-04'];
			$totals[4] += $row['ELV-54002915-50-00'];
			$totals[5] += $row['ELV-14445906-02-02'];
		}
	}
	
	// add in totals
	if (is_array($totals))
	{
		echo "<tr style='font-weight: bold; background-color: #dddddd'>\n";
		echo "<td>Totals: </td>\n";
		echo "<td style='text-align: center'>" . $totals[1] . "</td>\n";
		echo "<td style='text-align: center'>" . $totals[2] . "</td>\n";
		echo "<td style='text-align: center'>" . $totals[3] . "</td>\n";
		echo "<td style='text-align: center'>" . determineAverage($lookup['ELV-54002915-50-00']["code"]) . "</td>\n";
		echo "<td style='text-align: center'>" . $totals[5] . "</td>\n";
		echo "</tr>\n";
	}
}

// returns to the database to get the average for an entire day
function determineAverage($code) {
    global $mysqli;
	global $lookup;
	global $useDay;
	global $useMonth;
	global $useYear;
	
	$dataSource = $mysqli->query("
		select 
			avg(d.value) as average
		from 
			devicedata d, devices dv
		where 
				d.deviceid = dv.deviceid
			and
				dv.code = '$code'
			and	
				dayofmonth(d.timestamp) = $useDay
			and 
				month(d.timestamp) = $useMonth
			and 
				year(d.timestamp) = $useYear
		");
		
	while ($row = $dataSource->fetch_assoc()) {
		$returnValue = $row["average"];
	}
	
	$dataSource->close();
	return $returnValue;
}

?>